# All files / lib/http-proxy common.js

19.12% Statements 13/68
0% Branches 0/72
0% Functions 0/10
19.12% Lines 13/68

Press n or j to go to the next uncovered block, b, p or k for the previous block.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    2491x
    1x
    1x
    1x

    1x
    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

     var common   = exports,
        url      = require('url'),
        extend   = require('util')._extend,
        required = require('requires-port');

    var upgradeHeader = /(^|,)\s*upgrade\s*($|,)/i,
        isSSL = /^https|wss/;

    /**
     * Simple Regex for testing if protocol is https
     */
    common.isSSL = isSSL;
    /**
     * Copies the right headers from `options` and `req` to
     * `outgoing` which is then used to fire the proxied
     * request.
     *
     * Examples:
     *
     *    common.setupOutgoing(outgoing, options, req)
     *    // => { host: ..., hostname: ...}
     *
     * @param {Object} Outgoing Base object to be filled with required properties
     * @param {Object} Options Config object passed to the proxy
     * @param {ClientRequest} Req Request Object
     * @param {String} Forward String to select forward or target
     *
     * @return {Object} Outgoing Object with all required properties set
     *
     * @api private
     */

    common.setupOutgoing = function(outgoing, options, req, forward) {
      outgoing.port = options[forward || 'target'].port ||
                      (isSSL.test(options[forward || 'target'].protocol) ? 443 : 80);

      ['host', 'hostname', 'socketPath', 'pfx', 'key',
        'passphrase', 'cert', 'ca', 'ciphers', 'secureProtocol'].forEach(
        function(e) { outgoing[e] = options[forward || 'target'][e]; }
      );

      outgoing.method = options.method || req.method;
      outgoing.headers = extend({}, req.headers);

      if (options.headers){
        extend(outgoing.headers, options.headers);
      }

      if (options.auth) {
        outgoing.auth = options.auth;
      }

      if (options.ca) {
          outgoing.ca = options.ca;
      }

      if (isSSL.test(options[forward || 'target'].protocol)) {
        outgoing.rejectUnauthorized = (typeof options.secure === "undefined") ? true : options.secure;
      }

      outgoing.agent = options.agent || false;
      outgoing.localAddress = options.localAddress;

      //
      // Remark: If we are false and not upgrading, set the connection: close. This is the right thing to do
      // as node core doesn't handle this COMPLETELY properly yet.
      //
      if (!outgoing.agent) {
        outgoing.headers = outgoing.headers || {};
        if (typeof outgoing.headers.connection !== 'string'
            || !upgradeHeader.test(outgoing.headers.connection)
           ) { outgoing.headers.connection = 'close'; }
      }

      // the final path is target path + relative path requested by user:
      var target = options[forward || 'target'];
      var targetPath = target && options.prependPath !== false
        ? (target.path || '')
        : '';

      //
      // Remark: Can we somehow not use url.parse as a perf optimization?
      //
      var outgoingPath = !options.toProxy
        ? (url.parse(req.url).path || '')
        : req.url;

      //
      // Remark: ignorePath will just straight up ignore whatever the request's
      // path is. This can be labeled as FOOT-GUN material if you do not know what
      // you are doing and are using conflicting options.
      //
      outgoingPath = !options.ignorePath ? outgoingPath : '';

      outgoing.path = common.urlJoin(targetPath, outgoingPath);

      if (options.changeOrigin) {
        outgoing.headers.host =
          required(outgoing.port, options[forward || 'target'].protocol) && !hasPort(outgoing.host)
            ? outgoing.host + ':' + outgoing.port
            : outgoing.host;
      }
      return outgoing;
    };

    /**
     * Set the proper configuration for sockets,
     * set no delay and set keep alive, also set
     * the timeout to 0.
     *
     * Examples:
     *
     *    common.setupSocket(socket)
     *    // => Socket
     *
     * @param {Socket} Socket instance to setup
     *
     * @return {Socket} Return the configured socket.
     *
     * @api private
     */

    common.setupSocket = function(socket) {
      socket.setTimeout(0);
      socket.setNoDelay(true);

      socket.setKeepAlive(true, 0);

      return socket;
    };

    /**
     * Get the port number from the host. Or guess it based on the connection type.
     *
     * @param {Request} req Incoming HTTP request.
     *
     * @return {String} The port number.
     *
     * @api private
     */
    common.getPort = function(req) {
      var res = req.headers.host ? req.headers.host.match(/:(\d+)/) : '';

      return res ?
        res[1] :
        common.hasEncryptedConnection(req) ? '443' : '80';
    };

    /**
     * Check if the request has an encrypted connection.
     *
     * @param {Request} req Incoming HTTP request.
     *
     * @return {Boolean} Whether the connection is encrypted or not.
     *
     * @api private
     */
    common.hasEncryptedConnection = function(req) {
      return Boolean(req.connection.encrypted || req.connection.pair);
    };

    /**
     * OS-agnostic join (doesn't break on URLs like path.join does on Windows)>
     *
     * @return {String} The generated path.
     *
     * @api private
     */

    common.urlJoin = function() {
        //
        // We do not want to mess with the query string. All we want to touch is the path.
        //
      var args = Array.prototype.slice.call(arguments),
          lastIndex = args.length - 1,
          last = args[lastIndex],
          lastSegs = last.split('?'),
          retSegs;

      args[lastIndex] = lastSegs.shift();

      //
      // Join all strings, but remove empty strings so we don't get extra slashes from
      // joining e.g. ['', 'am']
      //
      retSegs = [
        args.filter(Boolean).join('/')
            .replace(/\/+/g, '/')
            .replace('http:/', 'http://')
            .replace('https:/', 'https://')
      ];

      // Only join the query string if it exists so we don't have trailing a '?'
      // on every request

      // Handle case where there could be multiple ? in the URL.
      retSegs.push.apply(retSegs, lastSegs);

      return retSegs.join('?')
    };

    /**
     * Rewrites or removes the domain of a cookie header
     *
     * @param {String|Array} Header
     * @param {Object} Config, mapping of domain to rewritten domain.
     *                 '*' key to match any domain, null value to remove the domain.
     *
     * @api private
     */
    common.rewriteCookieProperty = function rewriteCookieProperty(header, config, property) {
      if (Array.isArray(header)) {
        return header.map(function (headerElement) {
          return rewriteCookieProperty(headerElement, config, property);
        });
      }
      return header.replace(new RegExp("(;\\s*" + property + "=)([^;]+)", 'i'), function(match, prefix, previousValue) {
        var newValue;
        if (previousValue in config) {
          newValue = config[previousValue];
        } else if ('*' in config) {
          newValue = config['*'];
        } else {
          //no match, return previous value
          return match;
        }
        if (newValue) {
          //replace value
          return prefix + newValue;
        } else {
          //remove value
          return '';
        }
      });
    };

    /**
     * Check the host and see if it potentially has a port in it (keep it simple)
     *
     * @returns {Boolean} Whether we have one or not
     *
     * @api private
     */
    function hasPort(host) {
      return !!~host.indexOf(':');
    };